//+------------------------------------------------------------------+
//|                                                       ZigSig.mq4 |
//|                                                  paka christophe |
//|                                             guizmauh@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "paka christophe"
#property link      "guizmauh@hotmail.com"


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

// ZigZag parameters
extern int ExtDepth = 12 ;
extern int ExtDeviation = 5 ;
extern int ExtBack = 3 ;



//---- buffers

double signal[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0 , 2);
   SetIndexBuffer(0,signal);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int firstPointBar = Bars - 100; //the start point of the indicator
  
  
   int    counted_bars=IndicatorCounted();
   int i ;
   double rep ,
          trend ,
          test;
   
   double breaking = 0.0 ;
 
 //we use two loops to find two sucessive zigzag nonzero points, comparison of the two gives the trend
 i = firstPointBar ;
 
 while(breaking==0)
    { breaking= iCustom(NULL, 0 , "ZigZag" , ExtDepth , ExtDeviation , ExtBack , 0 , i ) ;
      i++ ;
      }
   rep=breaking ;
   
   breaking=0.0 ;
   
 while(breaking==0)
    { breaking = iCustom(NULL, 0 , "ZigZag" , ExtDepth , ExtDeviation , ExtBack , 0 , i ) ;
      i++ ;
      }
    i-- ;
    test = breaking ;
    if(breaking > rep) trend=-1 ; else trend=1 ;
  
  // once we have the start trend, we alternate the value of trend 
 // whenever we have a nonzero point as the behavior of the zigzag indicator   
 while(i>0)
   { breaking = iCustom(NULL, 0 , "ZigZag" , ExtDepth , ExtDeviation , ExtBack , 0 , i ) ;
     
     if(breaking != 0.0)
      if( ((breaking-test)*trend) > 0 ) // this test verify corresponding between previous zigzag trend and indicator trend
      { trend=-trend ;
        test=breaking;} 
                                 
                                        signal[i] = trend ;
                                       
                                        i--;
     
    }       
      
      
      
      
//----
   return(0);
  }
//+------------------------------------------------------------------+